

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

------------------------------------------------------------------------
entity keyboardVhdl is
   Port (   CLK, RST, KD, KC: in std_logic;
            an: out std_logic;
            led: out std_logic_vector (7 downto 0));


end keyboardVhdl;


architecture Behavioral of keyboardVhdl is


signal pclk : std_logic;
signal KDI, KCI : std_logic;
signal DFF1, DFF2 : std_logic;
signal ant : std_logic:='0';
signal shiftReg: std_logic_vector(10 downto 0):="00000000000";
signal shiftCounter: std_logic_vector(4 downto 0):="00001";
signal WaitReg: std_logic_vector (7 downto 0);



begin
--generating 25MHz
CLKDivider: Process (CLK)
begin
   if (CLK = '1' and CLK'Event) then 
      pclk <= not pclk; 
   end if;   
end Process;



--Flip Flops used to condition siglans coming from PS2--
Process (pclk, RST, KC, KD)
begin
      if(RST = '0') then
      DFF1 <= '0'; DFF2 <= '0'; KDI <= '0'; KCI <= '0';
   else                                    
      if (pclk = '1' and pclk'Event) then
         DFF1 <= KD; KDI <= DFF1; DFF2 <= KC; KCI <= DFF2;
      end if;
   end if;
end process;



Process(KDI, KCI, RST) 
begin                                                                 
   if (RST = '0') then
      ShiftReg <= "00000000000";
      
   else
      -- incrementing the shiftCounter and reading the data from PS2
      if (KCI = '0' and KCI'Event) then
         if (shiftCounter(4)='0') then 
            shiftCounter <= "10001";
		 ant<= '1';
         else
            if (shiftCounter="11010") then
               shiftCounter <=  "00000";
            else
               shiftCounter <= shiftCounter + 1;
			    ant<= '0';
            end if;
         end if;
         -- reading the data from PS2
         ShiftReg(10 downto 0) <= KDI & ShiftReg(10 downto 1);
         
      end if;
   end if;
end process;

--Wait Register
process( ShiftReg, RST, KCI)
begin
   if(RST = '0')then
      WaitReg <= "00000000";
   else
      if(KCI'event and KCI = '1' and shiftCounter = "00000" and 
               ShiftReg(0)='0' and ShiftReg(10)='1') then 
         -- waitreg will get the scancode 
         WaitReg <= ShiftReg(8 downto 1);
         -- we send an ALARM signal to the next component
        
         
      end if;         
   end if;
end Process;


led <=WaitReg(7 downto 0) when RST = '1' else    "00000000";

an<=ant;
            
end Behavioral;