/*-----copyright-----
 *     amy-studio - make development easier 
 *     web        : http://www.amy-studio.com
 *     taobao     : http://amy-studio.taobao.com
 *     qq(e_mail) : amystudio@qq.com
 *-----file info-----
 *     name       : lcd1602_test.v
 *     author     : Yuphone Chang
 *     description: LCD1602 display test 
 *----- version -----
 *     created    : 7.20, 2010
 *     version    : 1.0
 *     description: original version
 *
 *     modified   : 
 *     version    : 
 *     description: 
 *-------------------
 */

module lcd1602_test(
  input        CLOCK_50,                // global clock 
  input        Q_KEY,                   // asynchronous reset  
  // LCD1602 Interface
  output [7:0] LCD1602_DATA,            // data bus               
  output       LCD1602_E,               // chip enable 
  output       LCD1602_RS,              // data/instruction code 
  output       LCD1602_RW               // read/write 
);

// 0 ~ (8*16-1) = 128 bits binary code
// 16bits ascii code  -> 0123456789ABCDEF <-
wire [127:0] row1_val = "A Lcd Disp Test ";
wire [127:0] row2_val = "Amy-studio Pub  ";


// Instantiation of LCD1602 display drive module
lcd1602_drive u0(
  .clk              (CLOCK_50),
  .rst_n            (Q_KEY),
  // LCD1602 Input Value
  .row1_val         (row1_val),
  .row2_val         (row2_val),
  // LCD1602 Interface
  .lcd_data         (LCD1602_DATA),
  .lcd_e            (LCD1602_E),
  .lcd_rs           (LCD1602_RS),
  .lcd_rw           (LCD1602_RW)
);

endmodule
